/*
 * 쐬: 2004/07/30
 */
package jp.groupsession.v2.dba.meta;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import jp.co.sjts.util.jdbc.JDBCUtil;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * <br>[@  \] RlNVDB̃^擾
 * <br>[  ] gpRlNV̓N[YȂ̂ŁAʂ̃NXŃN[YB
 * <br>[  l]
 * @author JTS
 */
public class JdbcMetaExplorer {
    /** Logging CX^X */
    private static Log log__ = LogFactory.getLog(JdbcMetaExplorer.class);

    /** DBRlNV */
    private Connection con__ = null;

    /**
     * <br>[@  \] ftHgRXgN^
     * <br>[  ]
     * <br>[  l]
     */
    public JdbcMetaExplorer() {
    }

    /**
     * <br>[@  \] RlNVZbg
     * <br>[  ]
     * <br>[  l]
     * @param con RlNV
     */
    public JdbcMetaExplorer(Connection con) {
        con__ = con;
    }

    /**
     * <br>[@  \] RlNV擾܂B
     * <br>[  ]
     * <br>[  l]
     *
     * @return RlNV
     */
    public Connection getCon() {
        return con__;
    }

    /**
     * <br>[@  \] RlNVZbg܂B
     * <br>[  ]
     * <br>[  l]
     * @param con
     *            RlNV
     */
    public void setCon(Connection con) {
        con__ = con;
    }

    /**
     * <br>[@  \] e[uXL[}擾
     * <br>[  ]
     * <br>[  l]
     * @return XL[}
     * @throws SQLException SQLsO
     */
    public ArrayList<String> getTableSchema() throws SQLException {
        ArrayList<String> list = new ArrayList<String>();
        DatabaseMetaData objMet = con__.getMetaData();
        ResultSet rs = null;
        rs = objMet.getSchemas();

        while (rs.next()) {
            list.add(rs.getString("TABLE_SCHEM"));
        }

        return list;
    }

    /**
     * <br>[@  \] RlNV擾łSẴe[uԂ܂
     * <br>[  ]
     * <br>[  l]
     * @return SẴe[u
     * @throws SQLException SQLG[
     * @param getType 擾TABLE TYPE
     */
    @SuppressWarnings("unchecked")
    public ArrayList<String> getTableNames(String getType) throws SQLException {

        ArrayList<String> ret = new ArrayList<String>();
        ResultSet rs = null;

        ArrayList<String> schemas = getTableSchema();
        try {
            DatabaseMetaData meta = con__.getMetaData();
            String catalog = null;
            String schema = null;
            //TABLE LIST
            rs = meta.getTables(catalog, schema, "%", new String[]{});
            while (rs.next()) {
                String tableName = rs.getString("TABLE_NAME"); //TABLE_TYPE
                String tableType = rs.getString("TABLE_TYPE");

                log__.debug("TABLE_TYPE:" + rs.getString("TABLE_TYPE")
                          + " TABLE_NAME:" + rs.getString("TABLE_NAME"));
                //e[ȕꍇ̂ݒǉ
                if (isTable(tableType, getType)) {

//                    String pref = TypeMappingResourceBundle
//                            .getString("table_prefix");
                    //if (tableName.startsWith(pref)) {
                        ret.add(tableName);
                    //}
                }
                //String tableCat = rs2.getString("TABLE_CAT");
                //String tableSchem = rs2.getString("TABLE_SCHEM");
                //String tableType = rs2.getString("TABLE_TYPE");
                //String remarks = rs2.getString("REMARKS");
                //String typeCat = rs.getString("TYPE_CAT");
                //String typeSchem = rs.getString("TYPE_SCHEM");
                //String typeName = rs.getString("TYPE_NAME");
                //String selfRefencingColName =
                // rs.getString("SELF_REFERENCING_COL_NAME");
                //String refGeneration = rs.getString("REF_GENERATION");
            }
        } catch (SQLException e) {
            log__.error("e[u̎擾Ɏs", e);
            throw e;
        } finally {
            JDBCUtil.closeResultSet(rs);
        }
        return ret;
    }

    /**
     * <br>[@  \] ^񂩂擾e[u^CvAe[uǂ肵܂B
     * <br>[  ]
     * <br>[  l]
     * @param type ^Cv
     * @param getType 擾TABLE TYPE
     * @return true:e[uł, false:e[uł͂Ȃ
     */
    private boolean isTable(String type, String getType) {
        if (type == null) {
            return false;
        }

        boolean ret = false;
        //啶ɕϊăe[uǂ
        if (type.toUpperCase().equals(getType)) {
            ret = true;
        }
        return ret;
    }

    /**
     * <br>[@  \] w肵e[u擾B
     * <br>[  ]
     * <br>[  l]
     * @param tableName
     *            e[u
     * @return e[u
     * @throws SQLException
     *             SQLO
     */
    public Table getTable(String tableName) throws SQLException {

        Table table = new Table();
        //e[uZbg
        table.setName(tableName);

        //es̏擾
        ArrayList<Column> columns = getColumns(tableName);
        table.setColumns(columns);
        return table;
    }

    /**
     * <br>[@  \] RlNV擾łSẴe[u擾܂B
     * <br>[  ]
     * <br>[  l]
     * @return e[ũXg
     * @param getType 擾TABLE TYPE
     * @throws SQLException
     *             SQL̎sɎs
     */
    @SuppressWarnings("unchecked")
    public List<Table> getTables(String getType) throws SQLException {

        ArrayList<Table> ret = new ArrayList<Table>();

        ArrayList names = getTableNames(getType);
        Iterator it = names.iterator();
        while (it.hasNext()) {
            //
            String name = (String) it.next();
            Table tbl = getTable(name);
            ret.add(tbl);
        }
        return ret;
    }

    /**
     * <br>[@  \] w肵e[u̗擾
     * <br>[  ]
     * <br>[  l]
     * @param tableName e[u
     * @return Columni[ArrayList
     * @throws SQLException SQLO
     */
    public ArrayList<Column> getColumns(String tableName) throws SQLException {

        ArrayList<Column> columns = new ArrayList<Column>();
        DatabaseMetaData meta = con__.getMetaData();
        ResultSet rs = null;

        //̈ꗗ擾
        try {
            String catalog = null;
            String schema = null;
            rs = meta.getColumns(catalog, schema, tableName, null);
            while (rs.next()) {
                //
                String clmName = rs.getString("COLUMN_NAME");
                //f[^^
                short sdataType = rs.getShort("DATA_TYPE");
                //TCY
                int size = rs.getInt("COLUMN_SIZE");
                //x
                int digits = rs.getInt("DECIMAL_DIGITS");
                //NULL邩
                int nullAble = rs.getInt("NULLABLE");

                //Oraclep
                if (sdataType == 3 && digits <= 0) {
                    if (size <= 9) {
                        //INT
                        sdataType = 4;
                    } else {
                        //LONG
                        sdataType = 3;
                    }
                }

                Column col = new Column();
                col.setName(clmName);
                col.setType(sdataType);
                col.setSize(size);
                col.setDigits(digits);
                col.setNullable(nullAble);
                columns.add(col);
            }
        } catch (SQLException e) {
            throw e;
        } finally {
            if (rs != null) {
                rs.close();
            }
        }

        //L[擾A߂lɃZbg
        try {
            rs = meta.getPrimaryKeys(null, null, tableName);
            while (rs.next()) {
                //
                String clmName = rs.getString("COLUMN_NAME");
                //L[̘A
                short keySeq = rs.getShort("KEY_SEQ");
                //L[
                String pkName = rs.getString("PK_NAME");
                __setPrimaryKey(columns, clmName, keySeq);
            }
        } catch (SQLException e) {
            throw e;
        } finally {
            if (rs != null) {
                rs.close();
            }
        }
        return columns;
    }

    /**
     * <br>[@  \] L[Zbg
     * <br>[  ] L[ȂꍇnullԂ
     * <br>[  l]
     * @param cols 
     * @param clmName NX
     * @param keySeq L[NO
     * @return L[Zbg
     */
    private Column __setPrimaryKey(ArrayList cols, String clmName, short keySeq) {

        if (clmName == null) {
            return null;
        }

        //
        Iterator it = cols.iterator();
        Column col = null;
        while (it.hasNext()) {
            col = (Column) it.next();
            if (clmName.equals(col.getName())) {
                //PKEY̘AԂZbg
                col.setSeqKey(keySeq);
                break;
            } else {
                col = null;
            }
        }
        return col;
    }

    /**
     * <br>[@  \] RlNV琻iԂ
     * <br>[  ] JDBChCo̎󋵂ɂāA擾łȂڂ̂ł܂MpłȂ
     * <br>[  l]
     * @return i
     * @throws SQLException SQLsO
     */
    public Product getProductInfo() throws SQLException {
        Product product = new Product();

        DatabaseMetaData dbMetaData = con__.getMetaData();
        product.setProductName(dbMetaData.getDatabaseProductName());
        product.setProductVersion(dbMetaData.getDatabaseProductVersion());

        product.setDriverName(dbMetaData.getDriverName());
        product.setDriverVersion(dbMetaData.getDriverVersion());
        product.setDriverMajorVersion(dbMetaData.getDriverMajorVersion());
        product.setDriverMinorVersion(dbMetaData.getDriverMinorVersion());
        //        dbMetaData.getExtraNameCharacters();
        //        dbMetaData.getIdentifierQuoteString();
        //        dbMetaData.getMaxCatalogNameLength();
        //        dbMetaData.getMaxCharLiteralLength();
        product.setMaxColumnNameLength(dbMetaData.getMaxColumnNameLength());
        product.setMaxColumnsInGroupBy(dbMetaData.getMaxColumnsInGroupBy());
        product.setMaxColumnsInIndex(dbMetaData.getMaxColumnsInIndex());
        product.setMaxColumnsInOrderBy(dbMetaData.getMaxColumnsInOrderBy());
        product.setMaxColumnsInSelect(dbMetaData.getMaxColumnsInSelect());
        product.setMaxColumnsInTable(dbMetaData.getMaxColumnsInTable());
        //        dbMetaData.getMaxConnections();
        product.setMaxCursorNameLength(dbMetaData.getMaxCursorNameLength());
        product.setMaxIndexLength(dbMetaData.getMaxIndexLength());
        product.setMaxProcedureNameLength(dbMetaData
                .getMaxProcedureNameLength());
        product.setMaxRowSize(dbMetaData.getMaxRowSize());
        product.setMaxSchemaNameLength(dbMetaData.getMaxSchemaNameLength());
        product.setMaxStatementLength(dbMetaData.getMaxStatementLength());
        //        dbMetaData.getMaxStatements();
        product.setMaxTableNameLength(dbMetaData.getMaxTableNameLength());
        product.setMaxTablesInSelect(dbMetaData.getMaxTablesInSelect());
        product.setMaxUserNameLength(dbMetaData.getMaxUserNameLength());
        return product;
    }

    /**
     * <br>[@  \] ʃZbgÃwb_()擾B
     * <br>[  ]
     * <br>[  l]
     * @param rs ʃZbg
     * @return ʃZbg̃wb_()
     * @throws SQLException SQLsO
     */
    public ArrayList<String> getResultsetHeader(ResultSet rs) throws SQLException {
        ArrayList<String> ret = new ArrayList<String>();
        ResultSetMetaData rmeta = rs.getMetaData();
        int colCount = rmeta.getColumnCount();
        for (int i = 1; i <= colCount; i++) {
            String colName = rmeta.getColumnName(i);
            if (colName == null) {
                colName = "[NULL]";
            }
            ret.add(colName);
        }
        return ret;
    }
}