/*
 * create   : 2004/08/02
 * modified :
 */
package jp.groupsession.v2.dba.core;

import java.util.List;

import jp.groupsession.v2.dba.meta.Table;

/**
 * <br>[@  \] SqlGeneratorAbstractNX
 * <br>[  ]
 * <br>[  l]
 *
 * @author JTS
 */
public abstract class AbstractSqlGenerator {

    /** e[uIuWFNg */
    protected Table table_ = null;

    /**
     * <p>ftHgRXgN^
     */
    public AbstractSqlGenerator() {
    }

    /**
     * <p>e[uZbg
     * @param table Zbge[u
     */
    public AbstractSqlGenerator(Table table) {
        table_ = table;
    }

    /**
     * <p>e[u擾܂B
     * @return e[u
     */
    public Table getTable() {
        return table_;
    }

    /**
     * <p>e[uZbg܂B
     * @param table e[u
     */
    public void setTable(Table table) {
        table_ = table;
    }

    /**
     * <p>CreateTableSQL𐶐܂B(String)
     * @return create table 
     */
    public abstract String generateCreateTableSql();

    /**
     * <p>CreateTableSQL𐶐܂B(List)
     * @return Xg` create table
     */
    public abstract List generateCreateTableSqlList();

    /**
     * <p>DropTableSQL𐶐܂B(String)
     * @return drop table
     */
    public abstract String generateDropTableSql();

    /**
     * <p>DropTableSQL𐶐܂B(String)
     * @return Xg`drop table
     */
    public abstract List generateDropTableSqlList();

    /**
     * <p>InsertSQL𐶐܂B(String)
     * @return insert
     */
    public abstract String generateInsertSql();

    /**
     * <p>InsertSQL𐶐܂B(List)
     * @return Xg`insert
     */
    public abstract List generateInsertSqlList();

    /**
     * <p>InsertSQL𐶐܂B(String)
     * @return update
     */
    public abstract String generateUpdateSql();

    /**
     * <p>UpdateSQL𐶐܂B(List)
     * @return Xg`update
     */
    public abstract List generateUpdateSqlList();

    /**
     * <p>SelectSQL𐶐܂B(String)
     * @return select
     */
    public abstract String generateSelectSql();

    /**
     * <p>SelectSQL𐶐܂B(List)
     * @return Xg`select
     */
    public abstract List generateSelectSqlList();

    /**
     * <p>SelectSQL𐶐܂B(String)
     * @return select
     */
    public abstract String generateSelectAllSql();

    /**
     * <p>SelectSQL𐶐܂B(List)
     * @return Xg`select
     */
    public abstract List generateSelectSqlAllList();

    /**
     * <p>DeleteSQL𐶐܂B(String)
     * @return delete
     */
    public abstract String generateDeleteSql();

    /**
     * <p>DeleteSQL𐶐܂B(List)
     * @return Xg`delete
     */
    public abstract List generateDeleteSqlList();
}
