/*
 * 쐬: 2004/07/30
 */
package jp.groupsession.v2.dba.meta;

import java.io.Serializable;
import java.sql.DatabaseMetaData;
import java.sql.Types;

import jp.co.sjts.util.sort.IListSortable;

/**
 * <br>[@  \] e[u̗\NX
 * <br>[  ]
 * <br>[  l]
 * @author JTS
 */
public class Column implements Serializable, IListSortable {

    /**  */
    private String name__ = null;
    /** f[^^ */
    private int type__ = Types.NULL;
    /** TCY */
    private int size__ = -1;
    /** x */
    private int digits__ = -1;
    /**
     * Null̋
     * @see java.sql.DatabaseMetaData.columnNoNulls
     * @see java.sql.DatabaseMetaData.columnNullable
     * @see java.sql.DatabaseMetaData.columnNullableUnknown
     */
    int nullable__ = DatabaseMetaData.columnNullableUnknown;

    /** L[̘A */
    private int seqKey__ = NOT_KEYSEQ;

    /** L[ł͂ȂKeySeq̒l */
    public static final int NOT_KEYSEQ = -1;

    /**
     * <br>[@  \] ftHgRXgN^
     * <br>[  ]
     * <br>[  l]
     */
    public Column() {
    }

    /**
     * <br>[@  \] x擾܂
     * <br>[  ]
     * <br>[  l]
     * @return x
     */
    public int getDigits() {
        return digits__;
    }

    /**
     * <br>[@  \] 񖼂擾܂
     * <br>[  ]
     * <br>[  l]
     * @return 
     */
    public String getName() {
        return name__.toUpperCase();
    }

    /**
     * <br>[@  \] nulll邩擾܂
     * <br>[  ]
     * <br>[  l]
     * @return nulll邩ǂ
     */
    public int getNullable() {
        return nullable__;
    }

    /**
     * <br>[@  \] TCY擾܂
     * <br>[  ]
     * <br>[  l]
     * @return TCY
     */
    public int getSize() {
        return size__;
    }

    /**
     * <br>[@  \] ̃^Cv擾܂
     * <br>[  ]
     * <br>[  l]
     * @return ̃^Cv
     */
    public int getType() {
        return type__;
    }

    /**
     * <br>[@  \] xZbg܂
     * <br>[  ]
     * <br>[  l]
     * @param i x
     */
    public void setDigits(int i) {
        digits__ = i;
    }

    /**
     * <br>[@  \] 񖼂Zbg܂
     * <br>[  ]
     * <br>[  l]
     * @param string 
     */
    public void setName(String string) {
        name__ = string;
    }

    /**
     * <br>[@  \] nulll邩Zbg܂
     * <br>[  ]
     * <br>[  l]
     * @param i nulllZbg邩
     */
    public void setNullable(int i) {
        nullable__ = i;
    }

    /**
     * <br>[@  \] ̃TCYZbg܂
     * <br>[  ]
     * <br>[  l]
     * @param i TCY
     */
    public void setSize(int i) {
        size__ = i;
    }

    /**
     * <br>[@  \] ̃^CvZbg܂
     * <br>[  ]
     * <br>[  l]
     * @param i ̃^Cv
     */
    public void setType(int i) {
        type__ = i;
    }

    /**
     * <br>[@  \] L[̘AԂ擾܂
     * <br>[  ]
     * <br>[  l]
     * @return L[̘A
     */
    public int getSeqKey() {
        return seqKey__;
    }

    /**
     * <br>[@  \] L[̘AԂZbg܂
     * <br>[  ]
     * <br>[  l]
     * @param i L[̘A
     */
    public void setSeqKey(int i) {
        seqKey__ = i;
    }

    /**
     * <br>[@  \] ̃IuWFNg̕`Ԃ܂B
     * <br>[  ]
     * <br>[  l]
     * @return ̃IuWFNg̕`
     */
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("name = " + name__);
        buf.append(", type = " + JdbcMetaUtil.getTypeNameJdbcStandard(type__));
        buf.append(",  size = " + size__);
        buf.append(",  nullable = " + nullable__);
        buf.append(",  keySeq = " + seqKey__);
        return buf.toString();
    }

    /**
     * <br>[@  \] \[gL[Ԃ
     * <br>[  ]
     * <br>[  l]
     * @return \[gL[
     * @see jp.co.sjts.util.sort.IListSortable#getSortKey()
     */
    public Object getSortKey() {
        //
        return String.valueOf(seqKey__);
    }
}
